<?php
 include('Tools/xml.php');
 include('Tools/db.php');
 include('Tools/forms.php');
 include('Tools/panel.php');
 include('Tools/table.php');
 include('Tools/editor.php');

 if($TOOLS_DVD != true)
 {
   $DVE_SHOW = 20;

  /**************************
  * Load a DVD-file
  **************************/
  function dvdLoadFile($filename)
  {
   $dvdXml = new XML($filename);

   /**| FIELDS |**/
   $dvdFields=$dvdXml->evaluate("/view/fields/*");
   $DVD_FIELDS=array();
   foreach($dvdFields as $dvdField)
   {
    $dvdFieldAttributes = $dvdXml->get_attributes($dvdField);

    $DVD_FIELD=array("name"   => $dvdFieldAttributes["name"],
                     "title"  => $dvdFieldAttributes["title"],
                     "type"   => $dvdFieldAttributes["type"],
                     "query"  => $dvdFieldAttributes["query"],
                     "id"     => $dvdFieldAttributes["id"],
                     "delete" => $dvdFieldAttributes["delete"],
                     "null"   => $dvdFieldAttributes["null"],
                     "list"   => $dvdFieldAttributes["list"],
                     "edit"   => $dvdFieldAttributes["edit"]
                     );
    array_push($DVD_FIELDS,$DVD_FIELD);
   }

   /**| SELECTS |**/
   $DVD_SELECTS=array("list" => $dvdXml->get_content("/view[1]/selects[1]/list[1]"),
                      "edit" => $dvdXml->get_content("/view[1]/selects[1]/edit[1]"));

   /**| UPDATES |**/
   $dvdUpdates=$dvdXml->evaluate("/view/updates/*");
   $DVD_UPDATES=array();
   foreach($dvdUpdates as $dvdUpdate)
   {
    $dvdUpdate = $dvdXml->get_content($dvdUpdate);
    array_push($DVD_UPDATES,$dvdUpdate);
   }

   /**| INSERTS |**/
   $dvdInserts=$dvdXml->evaluate("/view/inserts/*");
   $DVD_INSERTS=array();
   foreach($dvdInserts as $dvdInsert)
   {
    $dvdInsert = $dvdXml->get_content($dvdInsert);
    array_push($DVD_INSERTS,$dvdInsert);
   }

   /**| DELETES |**/
   $dvdDeletes=$dvdXml->evaluate("/view/deletes/*");
   $DVD_DELETES=array();
   foreach($dvdDeletes as $dvdDelete)
   {
    $dvdDelete = $dvdXml->get_content($dvdDelete);
    array_push($DVD_DELETES,$dvdDelete);
   }

   /**| EVENTS |**/
   $dvdEvents=$dvdXml->evaluate("/view/events/*");
   $DVD_EVENTS=array();
   foreach($dvdEvents as $dvdEvent)
   {
    $dvdEventAttributes = $dvdXml->get_attributes($dvdEvent);
    $DVD_EVENT=array("name"   => $dvdEventAttributes["name"],
                     "event"  => $dvdEventAttributes["event"],
                     "time"   => $dvdEventAttributes["time"],
                     "code"   => $dvdXml->get_content($dvdEvent));
    array_push($DVD_EVENTS,$DVD_EVENT);
   }

   /**| ACTIONS |**/
   $dvdActions=$dvdXml->evaluate("/view/actions/*");
   $DVD_ACTIONS=array();
   foreach($dvdActions as $dvdAction)
   {
    $dvdActionAttributes = $dvdXml->get_attributes($dvdAction);
    $DVD_ACTION=array("title"   => $dvdActionAttributes["title"],
                      "view"    => $dvdActionAttributes["view"],
                      "params"  => $dvdActionAttributes["params"],
                     );
    array_push($DVD_ACTIONS,$DVD_ACTION);
   }

   /**| PARAMS |**/
   $dvdParams=$dvdXml->evaluate("/view/params/*");
   $DVD_PARAMS=array();
   foreach($dvdParams as $dvdParam)
   {
    $dvdParamAttributes = $dvdXml->get_attributes($dvdParam);
    $DVD_PARAM=array("name"          => $dvdParamAttributes["name"],
                      "defaultvalue" => $dvdParamAttributes["defaultvalue"],
                     );
    array_push($DVD_PARAMS,$DVD_PARAM);
   }

   /**| SECURITY |**/
   if($dvdXml->nodes["/view[1]"]["attributes"]["security"]=='1')
   {
    $dvdChecks=$dvdXml->evaluate("/view/security/*");
    $DVD_CHECKS=array();
    foreach($dvdChecks as $dvdCheck)
    {
     $dvdCheckAttributes = $dvdXml->get_attributes($dvdCheck);
     $DVD_CHECK=array("event"   => $dvdCheckAttributes["event"],
                      "group"   => $dvdCheckAttributes["group"],
                      );
     array_push($DVD_CHECKS,$DVD_CHECK);
    }
    $DVD_SECURITY=array(
                        "check" => $DVD_CHECKS,
                        "query"  => $dvdXml->nodes["/view[1]/security[1]"]["attributes"]["query"],
                        "title"  => $dvdXml->nodes["/view[1]/security[1]"]["attributes"]["title"]
                       );
   }

   $DVD_FILE=array("name"    => $dvdXml->nodes["/view[1]"]["attributes"]["name"],
                   "title"   => $dvdXml->nodes["/view[1]"]["attributes"]["title"],
                   "menu"    => $dvdXml->nodes["/view[1]"]["attributes"]["menu"],
                   "security"=> $dvdXml->nodes["/view[1]"]["attributes"]["security"],
                   "defaultlistorder"=> $dvdXml->nodes["/view[1]"]["attributes"]["defaultlistorder"],
                   "fields"  => $DVD_FIELDS,
                   "selects" => $DVD_SELECTS,
                   "updates" => $DVD_UPDATES,
                   "inserts" => $DVD_INSERTS,
                   "deletes" => $DVD_DELETES,
                   "events"  => $DVD_EVENTS,
                   "actions" => $DVD_ACTIONS,
                   "params"  => $DVD_PARAMS,
                   "checks"  => $DVD_SECURITY
                  );

   return $DVD_FILE;
  }

  /**************************
  * Substitute vars
  **************************/
  function dvdQueryVarReplace($DVD_QUERY,$DVD_FIELDS)
  {
   krsort($DVD_FIELDS);

   foreach($DVD_FIELDS as $DVD_FIELD_KEY=>$DVD_FIELD_VALUE)
   {
    $DVD_QUERY=str_replace('$'.$DVD_FIELD_KEY,$DVD_FIELD_VALUE,$DVD_QUERY);
   }
   return $DVD_QUERY;
  }

  /**************************
  * Edit a line
  **************************/
  function dvdEdit($DVD_FILE,$DVD_ID)
  {
   global $DVE_ACTION,$DVE_ORDER,$DVD_DATABASE;

   $FORM_NAMES=array();
   $FORM_TEXTS=array();
   $FORM_TYPES=array();
   $FORM_DATA=array();
   $FORM_FAULTS=array();
   $DVD_ID_NAME='';
   $DVD_REGISTER_VARS='';
   $DVD_UNREGISTER_VARS='';

   foreach($DVD_FILE["fields"] as $dvdField)
   {
    if($dvdField["edit"]==1)
    {
     array_push($FORM_NAMES,"DATA_".$dvdField["name"]);
     array_push($FORM_TEXTS,$dvdField["title"]);
     $fieldType=$dvdField["type"];
     foreach($DVD_FILE["params"] as $dvdParam)
     {
      if($dvdField["name"]==$dvdParam["name"]&&$GLOBALS[$dvdParam["name"]]!='')
      {
       $fieldType='show';
      }
     }
     array_push($FORM_TYPES,$fieldType);

     $DATA='';
     if($dvdField["type"]=='select')
     {
      $dvdDataQuery=dvdHtmlEntitiesConvert($dvdField["query"]);
      $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
      $DATA='<select name="%name%" class="form" style="width:100%;">';
      for($i=0;$i<mysql_num_rows($dvdDataResult);$i++)
      {
       $DATA.='<option value="'.mysql_result($dvdDataResult,$i,0).'">'.mysql_result($dvdDataResult,$i,1);
      }
      $DATA.="</select>";
     }
     array_push($FORM_DATA,$DATA);
     if($dvdField["null"]=='0')
     {
      $FORM_FAULTS["DATA_".$dvdField["name"]]=$dvdField["title"];
     }
     if($dvdField["id"]=='1')
     {
      $DVD_ID_NAME=$dvdField["name"];
     }
     $DVD_REGISTER_VARS.='$GLOBALS["DVD_'.$dvdField["name"].'"]=$'.$dvdField["name"].';'."\n".
                         '$'.$dvdField["name"].'=$GLOBALS["DATA_'.$dvdField["name"].'"];'."\n";
     $DVD_UNREGISTER_VARS.='$'.$dvdField["name"].'=$GLOBALS["DVD_'.$dvdField["name"].'"];'."\n".
                           'unset($GLOBALS["DVD_'.$dvdField["name"].'"]);'."\n";
    }
   }

   /**********************
   * Events
   **********************/
   foreach($DVD_FILE["events"] as $dvdEvent)
   {
    if($dvdEvent["event"]==$DVE_ACTION&&$dvdEvent["time"]=='before')
    {
     $file=fopen('dvd_event.php','w');
     fwrite ($file,"<?php\n".$DVD_REGISTER_VARS.dvdHtmlEntitiesConvert($dvdEvent["code"])."\n".$DVD_UNREGISTER_VARS."?>");
     fclose ($file);
     include('dvd_event.php');
     unlink('dvd_event.php');
    }
   }

   $FORM_WIDTH=array('100','*');
   switch($DVE_ACTION)
   {
    case 'catch' : $link=url("DVE_ACTION=insert");
                   break;
    case 'edit' :  $link=url("DVE_ACTION=update");
                   $dvdDataQuery=dvdQueryVarReplace(dvdHtmlEntitiesConvert($DVD_FILE["selects"]["edit"]),array($DVD_ID_NAME => $DVD_ID));
                   $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
                   $counter=0;
                   foreach($DVD_FILE["fields"] as $dvdField)
                   {
                    if($dvdField["edit"]=='1')
                    {
                     $GLOBALS['DATA_'.$dvdField["name"]]=mysql_result($dvdDataResult,0,$dvdField["name"]);
                     if($dvdField["type"]=='date')
                     {
                      if($GLOBALS['DATA_'.$dvdField["name"]]!='')
                      {
                       $sep=substr($GLOBALS['DATA_'.$dvdField["name"]],4,1);
                       $GLOBALS['DATA_DATE_SEP']=$sep;
                       list($GLOBALS['DATA_'.$dvdField["name"]."_year"],
                            $GLOBALS['DATA_'.$dvdField["name"]."_month"],
                            $GLOBALS['DATA_'.$dvdField["name"]."_day"])=sscanf($GLOBALS['DATA_'.$dvdField["name"]],"%d".$sep."%d".$sep."%d");
                      }
                     }
                     else
                     {
                      $GLOBALS['DATA_'.$dvdField["name"]]=mysql_result($dvdDataResult,0,$dvdField["name"]);
                     }
                    }
                   }

                   $formCheckpoints=dvdFormCheck($DVD_FILE);

/*
                   foreach($FORM_NAMES as $FORM_NAME)
                   {
                    $value=$FORM_NAME;
                    $get=substr($FORM_NAME,5,strlen($FORM_NAME)-5);
                    $GLOBALS[$FORM_NAME]=mysql_result($dvdDataResult,0,$get);
                    if($FORM_TYPES[$counter]=='date')
                    {
                     $DVD_DATE=mysql_result($dvdDataResult,0,$get);
                     if($DVD_DATE!='')
                     {
                      list($GLOBALS[$FORM_NAME."_year"],
                           $GLOBALS[$FORM_NAME."_month"],
                           $GLOBALS[$FORM_NAME."_day"])=sscanf($DVD_DATE,"%d.%d.%d");
                     }
                    }
                    else
                    {
                     $GLOBALS[$FORM_NAME]=mysql_result($dvdDataResult,0,$get);
                    }
                    $counter++;
                   }
*/

                   break;
    case 'insert': $DVD_UPDATE_FIELDS=array();
                   $DVD_FIELD_ID='';
                   foreach($DVD_FILE["fields"] as $dvdField)
                   {
                    if($dvdField["id"]==1)
                    {
                     $DVD_FIELD_ID=$dvdField["name"];
                    }
                    if($dvdField["edit"]==1)
                    {
                     if($dvdField["type"]=="date")
                     {
                      $sep=$GLOBALS['DATA_DATE_SEP'];
                      if($sep=='')
                      {
                       $sep='.';
                      }
                      $DVD_UPDATE_FIELDS[$dvdField["name"]]=sprintf("%04d".$sep."%02d".$sep."%02d",
                                                                    $GLOBALS["DATA_".$dvdField["name"]."_year"],
                                                                    $GLOBALS["DATA_".$dvdField["name"]."_month"],
                                                                    $GLOBALS["DATA_".$dvdField["name"]."_day"]);
                      $GLOBALS['DATA_'.$dvdField["name"]]=$DVD_UPDATE_FIELDS[$dvdField["name"]];
                     }
                     else
                     {
                      $DVD_UPDATE_FIELDS[$dvdField["name"]]=$GLOBALS["DATA_".$dvdField["name"]];
                     }
                    }
                   }
                   if($GLOBALS['DATA_'.$DVD_FIELD_ID]=='') $GLOBALS['DATA_'.$DVD_FIELD_ID]='#';

                   $formCheckpoints=dvdFormCheck($DVD_FILE);

                   if($formCheckpoints=='')
                   {
                    $link=url("DVE_ACTION=update");
                    foreach($DVD_FILE["inserts"] as $DVD_UPDATE)
                    {
                     $dvdDataQuery=dvdQueryVarReplace($DVD_UPDATE,$DVD_UPDATE_FIELDS);
                     $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
                    }
                   }
                   else
                   {
                    $link=url("DVE_ACTION=insert");
                   }

                   break;
    case 'update': $DVD_UPDATE_FIELDS=array();
                   foreach($DVD_FILE["fields"] as $dvdField)
                   {
                    if($dvdField["edit"]==1)
                    {
                     if($dvdField["type"]=="date")
                     {
                      $sep=$GLOBALS['DATA_DATE_SEP'];
                      if($sep=='')
                      {
                       $sep='.';
                      }
                      $DVD_UPDATE_FIELDS[$dvdField["name"]]=sprintf("%04d".$sep."%02d".$sep."%02d",
                                                                    $GLOBALS["DATA_".$dvdField["name"]."_year"],
                                                                    $GLOBALS["DATA_".$dvdField["name"]."_month"],
                                                                    $GLOBALS["DATA_".$dvdField["name"]."_day"]);
                      $GLOBALS['DATA_'.$dvdField["name"]]=$DVD_UPDATE_FIELDS[$dvdField["name"]];
                     }
                     else
                     {
                      $DVD_UPDATE_FIELDS[$dvdField["name"]]=$GLOBALS["DATA_".$dvdField["name"]];
                     }
                    }
                   }

                   $formCheckpoints=dvdFormCheck($DVD_FILE);
                   if($formCheckpoints=='')
                   {
                    $link=url("DVE_ACTION=list");
                    foreach($DVD_FILE["updates"] as $DVD_UPDATE)
                    {
                     $dvdDataQuery=dvdQueryVarReplace($DVD_UPDATE,$DVD_UPDATE_FIELDS);
//                     echo $dvdDataQuery;
                     $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
                    }
                   }
                   else
                   {
                    $link=url("DVE_ACTION=update");
                   }

                   break;
   }

   /**********************
   * Events
   **********************/
   foreach($DVD_FILE["events"] as $dvdEvent)
   {
    if($dvdEvent["event"]==$DVE_ACTION&&$dvdEvent["time"]=='after')
    {
     $file=fopen('dvd_event.php','w');
     fwrite ($file,"<?php\n".$DVD_REGISTER_VARS.dvdHtmlEntitiesConvert($dvdEvent["code"])."\n".$DVD_UNREGISTER_VARS."?>");
     fclose ($file);
     include('dvd_event.php');
     unlink('dvd_event.php');
    }
   }

   $DVD_RETURN='';
   if($DVE_ACTION=='catch'||$DVE_ACTION=='edit'||$formCheckpoints!='')
   {
    if($formCheckpoints!='') echo $formCheckpoints;
    $DVD_RETURN.=panel_open("Editing element of ".$DVD_FILE["title"]."");
    if($DVE_ACTION!='catch')
    {
     //$DVD_RETURN.=form_write($link,$FORM_NAMES,$FORM_TEXTS,$FORM_TYPES,$FORM_DATA,$FORM_FAULTS,$FORM_WIDTH,'   OK   ','color:#FF0000; font-weight:bold;');
     $DVD_RETURN.=dvdPrintForm($DVD_FILE,$link,$FORM_DATA,'color:#FF0000; font-weight:bold;');
    }
    else
    {
     // $DVD_RETURN.=form_write($link,$FORM_NAMES,$FORM_TEXTS,$FORM_TYPES,$FORM_DATA,$FORM_FAULTS,$FORM_WIDTH,'   OK   ','');
     $DVD_RETURN.=dvdPrintForm($DVD_FILE,$link,$FORM_DATA,'');
    }
    $DVD_RETURN.=panel_close();
   }
   else
   {
    $DVE_ACTION='list';
    $DVD_RETURN=dvdList($DVD_FILE);
   }

   return $DVD_RETURN;
  }

  /**************************
  * Converter function
  **************************/
  function dvdHtmlEntitiesConvert($STRING)
  {
   $STRING=str_replace('&quot;','"',$STRING);
   $STRING=str_replace('&lt;','<',$STRING);
   $STRING=str_replace('&gt;','>',$STRING);
//   $STRING=str_replace('&nbsp;',' ',$STRING);
   return $STRING;
  }

  /**************************
  * Create list of lines
  **************************/
  function dvdList($DVD_FILE)
  {
   global $DVE_ORDER,$DVE_LIMIT,$DVD_DATABASE,$DVE_ACTION,$DVE_SHOW,$DATA_SEARCH_OPERATOR,$DATA_SEARCH_VALUE,$DATA_SEARCH_FIELD;

   /**********************
   * Events
   **********************/
   foreach($DVD_FILE["events"] as $dvdEvent)
   {
    if($dvdEvent["event"]==$DVE_ACTION&&$dvdEvent["time"]=='before')
    {
     $file=fopen('dvd_event.php','w');
     fwrite ($file,"<?php\n".dvdHtmlEntitiesConvert($dvdEvent["code"])."\n"."?>");
     fclose ($file);
     include('dvd_event.php');
     unlink('dvd_event.php');
    }
   }

   $DVD_RETURN="
   <script>
    function DVD_DELETE(DVD_ID,DVD_TITLE)
    {
     Check = confirm('Are you sure to delete '+DVD_TITLE+'?');
     if(Check == true) document.location.href='".url("DVE_ACTION=delete")."&DVD_ID='+DVD_ID;
    }
   </script>
   ";

   /**| ORDER BY |**/
   $DVD_LIST_ORDER=' ORDER BY '.$DVD_FILE["defaultlistorder"];
   if($DVD_FILE["defaultlistorder"]=='') $DVD_LIST_ORDER='';
   if($DVE_ORDER!='')
   {
    $DVD_LIST_ORDER=' ORDER BY '.$DVE_ORDER;
   }

   /**| PARAMS |**/
   $DVD_PARAMS=array();
   foreach($DVD_FILE["params"] as $dvdParam)
   {
    if(isset($GLOBALS[$dvdParam["name"]])&&$GLOBALS[$dvdParam["name"]]!='')
    {
     $DVD_PARAMS[$dvdParam["name"]]=$GLOBALS[$dvdParam["name"]];
    }
    else
    {
     $DVD_PARAMS[$dvdParam["name"]]=$dvdParam["defaultvalue"];
    }
   }

   /**| QUERY |**/
   if(!isset($DVE_LIMIT)||$DVE_LIMIT=='') $DVE_LIMIT=0;

   $query=dvdHtmlEntitiesConvert($DVD_FILE["selects"]["list"]);

   $DATA_SEARCH_VALUE=$_POST['DATA_SEACH_VALUE'];
   if($DATA_SEARCH_VALUE=='') $DATA_SEARCH_VALUE=$_GET['DATA_SEACH_VALUE'];
   $DATA_SEARCH_OPERATOR=$_POST['DATA_SEARCH_OPERATOR'];
   if($DATA_SEARCH_OPERATOR=='') $DATA_SEARCH_OPERATOR=$_GET['DATA_SEARCH_OPERATOR'];
   $DATA_SEARCH_FIELD=$_POST['DATA_SEARCH_FIELD'];
   if($DATA_SEARCH_FIELD=='') $DATA_SEARCH_FIELD=$_GET['DATA_SEARCH_FIELD'];

   if($DATA_SEARCH_VALUE!='')
   {
      $pos=strpos($query,"WHERE");
      if($pos === false)
      {
       switch($DATA_SEARCH_OPERATOR)
       {
        case "co": $query.=" WHERE UPPER($DATA_SEARCH_FIELD) LIKE UPPER('%$DATA_SEARCH_VALUE%')";
                  break;
        case "eq": $query.=" WHERE UPPER($DATA_SEARCH_FIELD) = UPPER('$DATA_SEARCH_VALUE')";
                  break;
        case "ne": $query.=" WHERE NOT(UPPER($DATA_SEARCH_FIELD) = UPPER('$DATA_SEARCH_VALUE'))";
                  break;
        case "lt": $query.=" WHERE UPPER($DATA_SEARCH_FIELD) < UPPER('$DATA_SEARCH_VALUE')";
                  break;
        case "gt": $query.=" WHERE UPPER($DATA_SEARCH_FIELD) > UPPER('$DATA_SEARCH_VALUE')";
                  break;
       }
      }
      else
      {
       $pre=substr($query,0,$pos+5);
       $post=substr($query,$pos+5,strlen($query));
       switch($DATA_SEARCH_OPERATOR)
       {
        case "co": $query=$pre." UPPER($DATA_SEARCH_FIELD) LIKE UPPER('%$DATA_SEARCH_VALUE%') AND".$post;
                  break;
        case "eq": $query=$pre." UPPER($DATA_SEARCH_FIELD) = UPPER('$DATA_SEARCH_VALUE') AND".$post;
                  break;
        case "ne": $query=$pre." NOT(UPPER($DATA_SEARCH_FIELD) = UPPER('$DATA_SEARCH_VALUE')) AND".$post;
                  break;
        case "lt": $query=$pre." UPPER($DATA_SEARCH_FIELD) < UPPER('$DATA_SEARCH_VALUE') AND".$post;
                  break;
        case "gt": $query=$pre." UPPER($DATA_SEARCH_FIELD) > UPPER('$DATA_SEARCH_VALUE') AND".$post;
                  break;
       }
      }
   }

   $dvdDataQuery=dvdQueryVarReplace($query.$DVD_LIST_ORDER,$DVD_PARAMS);
   $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
   $dvdDataResults=mysql_num_rows($dvdDataResult);
   $dvdDataQuery=dvdQueryVarReplace($query.$DVD_LIST_ORDER." LIMIT ".$DVE_LIMIT.",".$DVE_SHOW,$DVD_PARAMS);
   $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);

   /**| TABLE |**/
   $DVD_TABLE=array();
   $DVD_TITLE=array();
   $DVD_LINKS=array();
   $DVD_ID='';
   $DVD_DELETE='';
   foreach($DVD_FILE["fields"] as $dvdField)
   {
    if($dvdField["delete"]=='1')
    {
     $DVD_DELETE=$dvdField["name"];
    }
    if($dvdField["id"]=='1')
    {
     $DVD_ID=$dvdField["name"];
    }
    if($dvdField["list"]=='1')
    {
     $dvdHead='<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr>
              <td valign="center" width="*" class="text">&nbsp;<b>'.$dvdField["title"].'</b></td>
              <td width="16" valign="center"><a href="'.url('DVE_ORDER='.$dvdField["name"].'%20ASC').'"><img src="Pictures/Icons/up.gif" alt="Sort ascending ..." border="0"></a><a href="'.url('DVE_ORDER='.$dvdField["name"].'%20DESC').'"><img src="Pictures/Icons/down.gif" alt="Sort descending ..." border="0"><a></td>
              </tr></table>';
     array_push($DVD_TITLE,$dvdHead);
     array_push($DVD_LINKS,url("DVE_LIMIT=0&DVE_ORDER=".$dvdField["name"]));
    }
   }
   array_push($DVD_TITLE,"&nbsp;Actions");
   array_push($DVD_LINKS,"");
   array_push($DVD_TABLE,$DVD_TITLE);

   for($i=0;$i<mysql_num_rows($dvdDataResult);$i++)
   {
    /**| AQUIRE PARAMS |**/
    $DVD_REPLACE_VARS=array();
    foreach($DVD_FILE["fields"] as $dvdField)
    {
     if($dvdField["list"]==1||$dvdField["id"]==1)
     {
      $DVD_REPLACE_VARS[$dvdField["name"]]=mysql_result($dvdDataResult,$i,$dvdField["name"]);
     }
    }


    $DVD_ACTIONS='<span class="text">';
    if(
       ($DVD_FILE["selects"]["edit"]!=''&&$DVD_FILE["security"]==0)
       ||
       (dvdHasRight($DVD_FILE,'edit')&&$DVD_FILE["selects"]["edit"]!=''&&$DVD_FILE["security"]==1)
      )
    {
     $DVD_ACTIONS.='<a href="'.url("DVE_ACTION=edit&DVD_ID=".mysql_result($dvdDataResult,$i,$DVD_ID)).'">edit</a> - ';
    }
    if(
       (count($DVD_FILE["deletes"])>0&&$DVD_FILE["security"]==0)
       ||
       (dvdHasRight($DVD_FILE,'delete')&&count($DVD_FILE["deletes"])>0&&$DVD_FILE["security"]==1)
      )
    {
     $DVD_ACTIONS.='<a href="javascript:DVD_DELETE(\''.mysql_result($dvdDataResult,$i,$DVD_ID).'\',\''.mysql_result($dvdDataResult,$i,$DVD_DELETE).'\')">delete</a> - ';
    }
    /**| GENERATE ACTIONS |**/
    foreach($DVD_FILE["actions"] as $dvdAction)
    {
     $DVD_ACTIONS.='<a href="'.dvdQueryVarReplace(url("DVE_ORDER=&DVE_ACTION=list&DVE_LIMIT=0&DVE_FILE=".$dvdAction["view"]."&".$dvdAction["params"]),$DVD_REPLACE_VARS).'">'.$dvdAction["title"].'</a> - ';
    }
    $DVD_ACTIONS=substr($DVD_ACTIONS,0,strlen($DVD_ACTIONS)-3).'</span>';

    $DVD_CONTENT=array();
    foreach($DVD_FILE["fields"] as $dvdField)
    {
     if($dvdField["list"]=='1')
     {
      if($dvdField["type"]=='select')
      {
       $dvdSelectQuery=dvdHtmlEntitiesConvert($dvdField["query"]);
       $dvdSelectResult=mysql_query($dvdSelectQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdSelectQuery);
       $found=0;
       for($ii=0;$ii<mysql_num_rows($dvdSelectResult);$ii++)
       {
        if(mysql_result($dvdSelectResult,$ii,0)==mysql_result($dvdDataResult,$i,$dvdField["name"]))
        {
         array_push($DVD_CONTENT,mysql_result($dvdSelectResult,$ii,1));
         $found=1;
        }
       }
       if($found==0) array_push($DVD_CONTENT,'&nbsp;');
       //array_push($DVD_CONTENT,mysql_result($dvdDataResult,$i,$dvdField["name"]));
      }
      elseif($dvdField["type"]=='boolean'||$dvdField["type"]=='booleanF'||$dvdField["type"]=='booleanT')
      {
       switch(mysql_result($dvdDataResult,$i,$dvdField["name"]))
       {
        case '0': array_push($DVD_CONTENT,'&nbsp;<img src="Pictures/Icons/boolean0.png" alt="'.$dvdField["name"].'='.mysql_result($dvdDataResult,$i,$dvdField["name"]).'">');
                  break;
        case '1': array_push($DVD_CONTENT,'&nbsp;<img src="Pictures/Icons/boolean1.png" alt="'.$dvdField["name"].'='.mysql_result($dvdDataResult,$i,$dvdField["name"]).'">');
                  break;
        default:  array_push($DVD_CONTENT,'&nbsp;<img src="Pictures/Icons/boolean.png" alt="'.$dvdField["name"].'='.mysql_result($dvdDataResult,$i,$dvdField["name"]).'">');
                  break;
       }
      }
      else
      {
       array_push($DVD_CONTENT,'&nbsp;'.str_replace('&nbsp;',' ',mysql_result($dvdDataResult,$i,$dvdField["name"])));
      }
     }
    }
    array_push($DVD_CONTENT,'&nbsp;'.$DVD_ACTIONS);
    array_push($DVD_TABLE,$DVD_CONTENT);


   }

   $DVD_RETURN.=panel_open("List of ".$DVD_FILE["title"]." ");
   $DVD_RETURN.='
 <table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
   <td style="height:30">
    <span class="text">Showing results '.($DVE_LIMIT+1).' to '.min($DVE_LIMIT+$DVE_SHOW,$dvdDataResults).' of '.$dvdDataResults.'</span>
    &nbsp;
';
if($DVE_LIMIT>0) $DVD_RETURN.='
    <input type="button" value="Previous '.$DVE_SHOW.'" style="width:70" class="text" onClick="location.href=\''.url("DVE_LIMIT=".($DVE_LIMIT-$DVE_SHOW)).'\'">
';
if(min($DVE_LIMIT+$DVE_SHOW,$dvdDataResults)<$dvdDataResults) $DVD_RETURN.='
    <input type="button" value="Next '.$DVE_SHOW.'" style="width:70" class="text" onClick="location.href=\''.url("DVE_LIMIT=".($DVE_LIMIT+$DVE_SHOW)).'\'">
   ';
   if(
      (count($DVD_FILE["inserts"])>0&&$DVD_FILE["security"]==0)
      ||
      (dvdHasRight($DVD_FILE,'catch')>0&&count($DVD_FILE["inserts"])>0&&$DVD_FILE["security"]==1)
     )
   {
    $DVD_RETURN.='
    </td>
    <form action="'.url('DVE_LIMIT=0').'" method="post">
    <td align="right">
     <select name="DATA_SEARCH_FIELD" class="text">';
    foreach($DVD_FILE["fields"] as $dvdField)
    {
     if($dvdField["list"]==1)
     {
      $DVD_RETURN.='<option value="'.$dvdField["name"].'"'.($DATA_SEARCH_FIELD == $dvdField["name"] ? ' selected' : '').'>'.$dvdField["title"];
     }
    }

    $DVD_RETURN.='
     </select>
     <select name="DATA_SEARCH_OPERATOR" class="text">
      <option value="co"'.($DATA_SEARCH_OPERATOR == 'co' ? ' selected' : '').'>~
      <option value="eq"'.($DATA_SEARCH_OPERATOR == 'eq' ? ' selected' : '').'>=
      <option value="ne"'.($DATA_SEARCH_OPERATOR == 'ne' ? ' selected' : '').'>!=
      <option value="lt"'.($DATA_SEARCH_OPERATOR == 'lt' ? ' selected' : '').'>&lt;
      <option value="gt"'.($DATA_SEARCH_OPERATOR == 'gt' ? ' selected' : '').'>&gt;
     </select>
     <input type="text" name="DATA_SEACH_VALUE" class="text" style="background:#ffffff; width:140" value="'.$DATA_SEARCH_VALUE.'">
     <input type="submit" class="text" style="width:70" value="Search">
     <input type="button" class="text" style="width:70" value="Clear" onClick="location.href=\''.url('DVD_SEARCH_VALUE=').'\'">
     -
     <input type="button" value="Add line" style="width:70" class="text" onClick="location.href=\''.url("DVE_ACTION=catch").'\'">
    </td>
    </form>';
   }
   $DVD_RETURN.='
  </tr>
 </table>
   ';
   $DVD_RETURN.=table_write_links($DVD_TABLE,$DVD_LINKS);
   $DVD_RETURN.=panel_close();

   /**********************
   * Events
   **********************/
   foreach($DVD_FILE["events"] as $dvdEvent)
   {
    if($dvdEvent["event"]==$DVE_ACTION&&$dvdEvent["time"]=='after')
    {
     $file=fopen('dvd_event.php','w');
     fwrite ($file,"<?php\n".dvdHtmlEntitiesConvert($dvdEvent["code"])."\n"."?>");
     fclose ($file);
     include('dvd_event.php');
     unlink('dvd_event.php');
    }
   }

   return $DVD_RETURN;
  }

  /**************************
  * Delete a line
  **************************/
  function dvdDelete($DVD_FILE,$DVD_ID)
  {
   global $DVD_DATABASE,$DVE_ACTION;

   /**| ID |**/
   $DVD_ID_NAME='';
   $DVD_REGISTER_VARS='';
   $DVD_UNREGISTER_VARS='';
   foreach($DVD_FILE["fields"] as $dvdField)
   {
    if($dvdField["id"]=="1")
    {
     $DVD_ID_NAME=$dvdField["name"];
     $DVD_REGISTER_VARS.='$GLOBALS["DVD_'.$dvdField["name"].'"]=$'.$dvdField["name"].';'."\n".
                         '$'.$dvdField["name"].'=$DVD_ID;'."\n";
     $DVD_UNREGISTER_VARS.='$'.$dvdField["name"].'=$GLOBALS["DVD_'.$dvdField["name"].'"];'."\n".
                           'unset($GLOBALS["DVD_'.$dvdField["name"].'"]);'."\n";
    }
   }

   /**********************
   * Events
   **********************/
   foreach($DVD_FILE["events"] as $dvdEvent)
   {
    if($dvdEvent["event"]==$DVE_ACTION&&$dvdEvent["time"]=='before')
    {
     $file=fopen('dvd_event.php','w');
     fwrite ($file,"<?php\n".$DVD_REGISTER_VARS.dvdHtmlEntitiesConvert($dvdEvent["code"])."\n".$DVD_UNREGISTER_VARS."?>");
     fclose ($file);
     include('dvd_event.php');
     unlink('dvd_event.php');
    }
   }

   /**| QUERY |**/
   $dvdDataQuery=dvdQueryVarReplace(dvdHtmlEntitiesConvert($DVD_FILE["selects"]["edit"]),array($DVD_ID_NAME => $DVD_ID));
   $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);

   /**| FIELDS |**/
   $DVD_FIELDS=array();
   foreach($DVD_FILE["fields"] as $dvdField)
   {
    if($dvdField['edit']==1)
    {
     $DVD_FIELDS[$dvdField["name"]]=mysql_result($dvdDataResult,0,$dvdField["name"]);
    }
   }

   foreach($DVD_FILE["deletes"] as $dvdDelete)
   {
    $dvdDeleteQuery=dvdQueryVarReplace(dvdHtmlEntitiesConvert($dvdDelete),$DVD_FIELDS);
    $dvdDataResult=mysql_query($dvdDeleteQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDeleteQuery);
   }

   /**********************
   * Events
   **********************/
   foreach($DVD_FILE["events"] as $dvdEvent)
   {
    if($dvdEvent["event"]==$DVE_ACTION&&$dvdEvent["time"]=='after')
    {
     $file=fopen('dvd_event.php','w');
     fwrite ($file,"<?php\n".$DVD_REGISTER_VARS.dvdHtmlEntitiesConvert($dvdEvent["code"])."\n".$DVD_UNREGISTER_VARS."?>");
     fclose ($file);
     include('dvd_event.php');
     unlink('dvd_event.php');
    }
   }
  }

  /**********************
  * Check incoming data
  **********************/
  function dvdFormCheck($DVD_FILE)
  {
   $dvdMissing=array();
   foreach($DVD_FILE["fields"] as $dvdField)
   {
    if($dvdField["edit"]=='1')
    {
     //echo 'DATA_'.$dvdField["name"].' = '.$GLOBALS['DATA_'.$dvdField["name"]].'<br>';
     if($dvdField["type"]=='date')
     {
      if(($GLOBALS['DATA_'.$dvdField["name"].'_year']==''||
          $GLOBALS['DATA_'.$dvdField["name"].'_month']==''||
          $GLOBALS['DATA_'.$dvdField["name"].'_day']=='')&&
          $dvdField["null"]=='0')
      {
       $fields='';
       if($GLOBALS['DATA_'.$dvdField["name"].'_year']=='') ($fields=='' ? $fields='year' : $fields.=',year');
       if($GLOBALS['DATA_'.$dvdField["name"].'_month']=='') ($fields=='' ? $fields='month' : $fields.=',month');
       if($GLOBALS['DATA_'.$dvdField["name"].'_day']=='') ($fields=='' ? $fields='day' : $fields.=',day');
       array_push($dvdMissing,$dvdField["title"].' ('.$fields.')');
      }
     }
     else
     {
      //echo $GLOBALS['DATA_'.$dvdField["name"]]."==''&&".$dvdField["null"]."=='0'<br>";
      if($GLOBALS['DATA_'.$dvdField["name"]]==''&&
         $dvdField["null"]=='0')
      {
       array_push($dvdMissing,$dvdField["title"]);
      }
     }
    }
   }

   $DVD_RETURN='';
   if(count($dvdMissing)>0)
   {
    $DVD_RETURN.=panel_open("ERROR: The following fields are still required! ");
    $DVD_RETURN.=liste_write($dvdMissing);
    $DVD_RETURN.=panel_close();
    $DVD_RETURN.='<br>';
   }
   return $DVD_RETURN;
  }

  /**********************
  * Print form
  **********************/
  function dvdPrintForm($DVD_FILE,$dvdLink,$dvdData,$dvdCheckStyle)
  {
   global $DVD_DATABASE, $DVE_ACTION;

   $FORM_RETURN='<form name="form" action="'.$dvdLink.'" method="post" enctype="multipart/form-data">';
   $FORM_EXTRACODE='';
   $formTable = array(array('&nbsp;Field','&nbsp;Value','&nbsp;'));

   $count=0;
   $GET_FIELDS = array();
   foreach($DVD_FILE["fields"] as $dvdField)
   {
    if($dvdField["edit"]=='1')
    {
     $fieldKey='DATA_'.$dvdField["name"];
     $fieldValue=$GLOBALS[$fieldKey];
     $fieldShow=$fieldValue;

     $isParam=false;
     foreach($DVD_FILE["params"] as $dvdParam)
     {
      if($dvdParam["name"]==$dvdField["name"]&&$GLOBALS[$dvdField["name"]]!='')
      {
       $isParam=true;
      }
     }

     if($dvdField["type"]=='hidden'||$dvdField["type"]=='show'||$isParam==true)
     {
      if($isParam==true&&$dvdField["query"]!='')
      {
       $dvdDataQuery=dvdHtmlEntitiesConvert($dvdField["query"]);
       $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
       for($i=0;$i<mysql_num_rows($dvdDataResult);$i++)
       {
        if($DVE_ACTION=='catch')
        {
         if(mysql_result($dvdDataResult,$i,0)===$GLOBALS[$dvdField["name"]])
         {
          $fieldShow=mysql_result($dvdDataResult,$i,1);
          $fieldValue=mysql_result($dvdDataResult,$i,0);
         }
        }
        else
        {
         if(mysql_result($dvdDataResult,$i,0)===$fieldValue)
         {
          $fieldShow=mysql_result($dvdDataResult,$i,1);
         }
        }
       }
      }

      switch($dvdField["type"])
      {
       case 'hidden':   $FORM_EXTRACODE.='<input type="hidden" name="'.$fieldKey.'" value="'.str_replace ('"', '\"', $fieldValue).'">';
                        break;
       default:         $formValue='<span class="text">&nbsp;'.$fieldShow.'</span>';
                        $FORM_EXTRACODE.='<input type="hidden" name="'.$fieldKey.'" value="'.str_replace ('"', '\"', $fieldValue).'">';
                        array_push($formTable,array($dvdField["title"],$formValue,'&nbsp;'));
                        break;
      }
     }
     else
     {
      $dvdChamps='';
      if((($fieldValue==''||!isset($GLOBALS[$fieldKey]))&&$dvdField["null"]=='0'&&$dvdCheckStyle!='') )
      {
       $dvdChamps.='<span style="'.$dvdCheckStyle.'">';
      }
      $dvdChamps.=str_replace(' ','&nbsp;',$dvdField["title"]);
      if((($fieldValue==''||!isset($GLOBALS[$fieldKey]))&&$fautes[$fieldKey]!=''&&$dvdCheckStyle!='') )
      {
       $dvdChamps.='</span>';
      }

      switch($dvdField["type"])
      {
 /*      case 'checkbox': $to='<input type="'.$types[$count].'" name="'.$field.'" '.$value.' class="form" style="width:100%;">';
                        break;*/
       case 'text':     $formValue='<input type="'.$dvdField["type"].'" name="'.$fieldKey.'" value="'.str_replace ('"', '&quot;', $fieldValue).'" class="form" style="width:100%;">';
                        break;
       case 'password': IF($DVE_ACTION=='edit')
                        {
                         $fieldValue='';
                        }
                        $formValue='<input type="'.$dvdField["type"].'" name="'.$fieldKey.'" value="'.str_replace ('"', '&quot;', $fieldValue).'" class="form" style="width:100%;">';
                        break;
       case 'date':     $formValue='<input type="hidden" name="DATA_DATE_SEP" value="'.$GLOBALS['DATA_DATE_SEP'].'">';
                        $formValue.='<select name="'.$fieldKey.'_day" class="form" style="width:33%"';
                        if($GLOBALS[$fieldKey.'_day']==''||!isset($GLOBALS[$fieldKey.'_day'])) $formValue.=' style="'.$dvdCheckStyle.'"';
                        $formValue.='><option value="">--- jour ---';
                        for ($z=1;$z<=31;$z++)
                        {
                         $formValue.= '<option value="'.$z.'"';
                         if($GLOBALS[$fieldKey.'_day']==$z) {$formValue.= " selected";}
                         $formValue.= '>'.$z.'</option>';
                        }
                        $formValue.='</select>.<select name="'.$fieldKey.'_month" class="form" style="width:33%"';
                        if($GLOBALS[$fieldKey.'_month']==''||!isset($GLOBALS[$fieldKey.'_month'])) $formValue.=' style="'.$dvdCheckStyle.'"';
                        $formValue.='><option value="">--- mois ---';
                        for ($z=1;$z<=12;$z++)
                        {
                         $formValue.= '<option value="'.$z.'"';
                         if($GLOBALS[$fieldKey.'_month']==$z) {$formValue.= " selected";}
                         $formValue.= '>'.$z.'</option>';
                        }
                        $formValue.='</select>.<select name="'.$fieldKey.'_year" class="form" style="width:33%"';
                        if($GLOBALS[$fieldKey.'_year']==''||!isset($GLOBALS[$fieldKey.'_year'])) $formValue.=' style="'.$dvdCheckStyle.'"';
                        $formValue.='><option value="">--- anne ---';
                        for ($z=2010;$z>=1900;$z--)
                        {
                        $formValue.= '<option value="'.$z.'"';
                         if($GLOBALS[$fieldKey.'_year']==$z) {$formValue.= " selected";}
                         $formValue.= '>'.$z.'</option>';
                         }
                        $formValue.='</select>';
                        break;
       case 'textarea': if(inAgent('MSIE'))
                        {
                         $formValue=writeEditor($fieldKey.'Editor',200,str_replace("\n","",str_replace("\r","",$fieldValue)));
                         array_push($GET_FIELDS,$fieldKey);
                         $formValue.='<input type="hidden" name="'.$fieldKey.'" value="">';
                        }
                        else
                        {
                         $formValue='<textarea name="'.$fieldKey.'" class="form" style="width:100%;" rows="5">'.$fieldValue.'</textarea>';
                        }
                        break;
       case 'file':     $formValue=$fieldValue.'<input type="'.$dvdField["type"].'" name="'.$fieldKey.'" value="'.$fieldValue.'" class="form" style="width:100%;">';
                        break;
       case 'select':   $formValue=str_replace('%name%',$fieldKey,$dvdData[$count]);
                        $formValue=str_replace('value="'.$fieldValue.'"','value="'.$fieldValue.'" selected',$formValue);
                        break;
       case 'boolean':  $formValue=str_replace('%name%',$fieldKey,'<select name="%name%" class="form" style="width:100%;"><option value="1">OUI<option value="0">NON<option value="2">Je ne sais pas</select>');
                        $formValue=str_replace('value="'.$fieldValue.'"','value="'.$fieldValue.'" selected',$formValue);
                        break;
       case 'booleanT':  $formValue=str_replace('%name%',$fieldKey,'<select name="%name%" class="form" style="width:100%;"><option value="1">OUI<option value="0">NON<option value="2">Je ne sais pas</select>');
                        $formValue=str_replace('value="'.$fieldValue.'"','value="'.$fieldValue.'" selected',$formValue);
                        break;
       case 'booleanF':  $formValue=str_replace('%name%',$fieldKey,'<select name="%name%" class="form" style="width:100%;"><option value="0">NON<option value="1">OUI<option value="2">Je ne sais pas</select>');
                        $formValue=str_replace('value="'.$fieldValue.'"','value="'.$fieldValue.'" selected',$formValue);
                        break;
       default:         break;
      }

      $formCheck='&nbsp;';
      if($dvdField["null"]==0)
      {
       $formCheck='<img src="Pictures/Icons/red$.png" alt="must not be empty">';
      }

      array_push($formTable,array('&nbsp;'.str_replace('&nbsp;',' ',$dvdChamps),$formValue,$formCheck));
     }
     $count++;
    }
   }

   $FORM_RETURN.= '<script>
                    function go()
                    {
                   ';
   foreach ($GET_FIELDS as $getField)
   {
    $FORM_RETURN.= ' document.form.'.$getField.'.value=GetHtml('.$getField.'Editor);';
//    $FORM_RETURN.= ' alert(GetHtml('.$getField.'Editor));';
   }
   $FORM_RETURN.= ' document.form.submit();
                    }
                  </script>';

   $FORM_RETURN.=table_write_widths_simple($formTable,array('150','*','1%')).$FORM_EXTRACODE.'
     <div align="right">
      <br>
<!--      <input type="button" value="Cancel" class="text"  onClick="history.back()" >
      &nbsp;-->
      <input type="button" value="    OK    " class="text" onClick="go()"></div></form>
    ';
   return $FORM_RETURN;
  }


  /**********************
  * Print Error page
  **********************/
  function dvdError()
  {
   $RETURN_ERROR='
   <html>
    <head>
     <title>Error #401</title>
    </head>
    <body bgcolor="#0000FF" leftmargin="0" topmargin="0" marginheight="0" marginwidth="0">
    <table border="0" width="100%" height="100%" cellpadding="0" cellsapcing="0" bgcolor="#0000FF">
     <tr>
      <td bgcolor="#0000FF" align="left" valign="center">
       <center>
        <table bgcolor="#FFFFFF">
         <tr>
          <td bgcolor="#FFFFFF">
           <font face="MS Sans Serif" size="+2" color="#000000"><b>&nbsp;Error #401&nbsp;</b></font>
          </td>
         </tr>
        </table>
        <br>
        <br>
        <br>
        <table>
         <tr>
          <td>
           <font face="MS Sans Serif" size="+2" color="#FFFFFF"><b>
            You are getting this nice blue - screen because you tried
            <br>
            to acces a protected page without having the nessassary
            <br>
            rights!
            <br>
            <br>
            Please try again or contact your server administrator ...
           </b></font>
          </td>
         </tr>
        </table>
       </center>
      </td>
     </tr>
    </table>
    </body>
   </html>
   ';
   return $RETURN_ERROR;
  }

  /**********************
  * Check security, exit
  **********************/
  function dvdSecurityCheck($DVD_FILE)
  {
   global $DVE_ACTION,$PHP_AUTH_USER,$PHP_AUTH_PW,$DVD_DATABASE,$DVE_FILE;

   if($DVD_FILE["security"]==1)
   {

    if(!isset($PHP_AUTH_USER) || !isset($PHP_AUTH_PW) || $PHP_AUTH_USER=='' || $PHP_AUTH_PW=='')
    {
     $realm=$DVD_FILE["checks"]["title"].' for '.$DVE_FILE.'.'.$DVE_ACTION;
     Header("WWW-authenticate: Basic realm=\"$realm\"");
     Header("HTTP/1.0 401 Unauthorized");
     echo dvdError();
     exit;
    }
    else
    {
     $dvdSecurityOK=0;
     foreach($DVD_FILE["checks"]["check"] as $dvdCheck)
     {
      if($dvdCheck["event"]==$DVE_ACTION)
      {
       $dvdSecurityParams=array("user"     => $PHP_AUTH_USER,
                                "password" => $PHP_AUTH_PW,
                                "group"    => $dvdCheck["group"]
                               );

       $dvdDataQuery=dvdQueryVarReplace(dvdHtmlEntitiesConvert($DVD_FILE["checks"]["query"]),$dvdSecurityParams);
       $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
       $dvdSecurityOK+=mysql_num_rows($dvdDataResult);
      }
     }

     if($dvdSecurityOK==0)
     {
      $realm=$DVD_FILE["checks"]["title"].' for '.$DVE_FILE.'.'.$DVE_ACTION;
      Header("WWW-authenticate: Basic realm=\"$realm\"");
      Header("HTTP/1.0 401 Unauthorized");
      echo dvdError();
      exit;
     }
    }
    flush();
   }
  }

  /**********************
  * Check right
  **********************/
  function dvdHasRight($DVD_FILE,$DVE_ACTION)
  {
   global $PHP_AUTH_USER,$PHP_AUTH_PW,$DVD_DATABASE;

   $dvdSecurityOK=0;
   foreach($DVD_FILE["checks"]["check"] as $dvdCheck)
   {
    if($dvdCheck["event"]==$DVE_ACTION)
    {
     $dvdSecurityParams=array("user"     => $PHP_AUTH_USER,
                              "password" => $PHP_AUTH_PW,
                              "group"    => $dvdCheck["group"]
                             );
     $dvdDataQuery=dvdQueryVarReplace(dvdHtmlEntitiesConvert($DVD_FILE["checks"]["query"]),$dvdSecurityParams);
     $dvdDataResult=mysql_query($dvdDataQuery,$DVD_DATABASE) or mysql_die("Query error: ".$dvdDataQuery);
     $dvdSecurityOK+=mysql_num_rows($dvdDataResult);
    }
   }

   return $dvdSecurityOK;
  }
 }
 $TOOLS_DVD = true;

 function dveMenuUrl($str)
 {
  $check = array('DVE_ORDER'=>$GLOBALS['DVE_ORDER'],
                 'DVE_ACTION'=>$GLOBALS['DVE_ACTION'],
                 'DVE_LIMIT'=>$GLOBALS['DVE_LIMIT'],
                 'DVE_FILE'=>$GLOBALS['DVE_FILE'],
                 'DATA_SEARCH_FIELD'=>$GLOBALS['DATA_SEARCH_FIELD'],
                 'DATA_SEARCH_OPERATOR'=>$GLOBALS['DATA_SEARCH_OPERATOR'],
                 'DATA_SEARCH_VALUE'=>$GLOBALS['DATA_SEARCH_VALUE'],
                );

  parse_str($str,$params);
  foreach($params as $key=>$val)
  {
   $check[$key]=$val;
  }

  $url = '';
  foreach($check as $key=>$val)
  {
   if($url!='') {$url.='&';}
   $url.=$key."=".$val;
  }
  $url=$GLOBALS["SCRIPT_NAME"]."?".$url;

  return $url;
 }

 function url($str)
 {
  global $DVD_FILE;

  foreach($DVD_FILE["params"] as $dvdParam)
  {
   $str.='&'.$dvdParam["name"].'='.$GLOBALS[$dvdParam["name"]];
  }

  return dveMenuUrl($str);
 }

 function inAgent($agent)
 {
  global $HTTP_USER_AGENT;
  $notAgent = strpos($HTTP_USER_AGENT,$agent) === false;
  return !$notAgent;
 }

?>
